﻿'
' Copyright (c) 2009-2013, MindFusion LLC - Bulgaria.
'
Imports MindFusion.Scheduling
Imports MindFusion.Scheduling.WebForms

Public Class BirthdayAppointment
	Inherits Appointment
	Public Sub New()
		Me.New(DateTime.Today, [String].Empty)
	End Sub

	Public Sub New(ByVal birthDate As DateTime, ByVal birthdayPerson As String)
		MyBase.New()
		Me.BirthDate = birthDate
		Me.BirthdayPerson = birthdayPerson
		Me.HeaderText = [String].Format("{0}'s B-day!", birthdayPerson)
		Me.Recurrence = CreateBirthdayRecurrence(birthDate)
		Me.AllDayEvent = True
		Me.Locked = True
		CssClass = "CustomAppStyle"
	End Sub

	Public Property BirthDate() As DateTime
		Get
			Return m_BirthDate
		End Get
		Private Set(ByVal value As DateTime)
			m_BirthDate = value
		End Set
	End Property
	Private m_BirthDate As DateTime

	Public Property BirthdayPerson() As String
		Get
			Return m_BirthdayPerson
		End Get
		Set(ByVal value As String)
			m_BirthdayPerson = value
		End Set
	End Property
	Private m_BirthdayPerson As String

	Private Function CreateBirthdayRecurrence(ByVal birthDate As DateTime) As Recurrence
		Dim rec As New Recurrence()
		rec.StartDate = birthDate.[Date]
		rec.Pattern = RecurrencePattern.Yearly
		rec.YearlyRecurrence = YearlyRecurrence.SpecificDate
		rec.DayOfMonth = birthDate.Day
		rec.MonthOfYear = birthDate.Month
		rec.RecurrenceEnd = RecurrenceEnd.Never
		Return rec
	End Function

	Public Overrides Function SaveViewState() As Object
		ViewState("_birthDate") = BirthDate
		ViewState("_birthdayPerson") = BirthdayPerson
		Return MyBase.SaveViewState()
	End Function

	Public Overrides Sub LoadViewState(ByVal state As Object)
		MyBase.LoadViewState(state)
		If ViewState("_birthDate") IsNot Nothing Then
			BirthDate = DateTime.Parse(ViewState("_birthDate").ToString())
		End If
		If ViewState("_birthdayPerson") IsNot Nothing Then
			BirthdayPerson = ViewState("_birthdayPerson").ToString()
		End If
	End Sub

	Protected Overrides Sub CopyOccurrence(ByVal master As Item)
		Dim bMaster As BirthdayAppointment = TryCast(master, BirthdayAppointment)
		BirthdayPerson = bMaster.BirthdayPerson
		BirthDate = bMaster.BirthDate
		MyBase.CopyOccurrence(master)
	End Sub

End Class
