﻿'
' Copyright (c) 2009-2013, MindFusion LLC - Bulgaria.
'
Imports MindFusion.Scheduling
Imports MindFusion.Scheduling.WebForms

Public Class BirthdayAppointmentConverter
	Inherits ItemConverter
	Public Sub New(ByVal calendar As Calendar)
		MyBase.New(calendar)
	End Sub

	Public Overrides ReadOnly Property SupportedTypes() As IEnumerable(Of Type)
		Get
			Return New List(Of Type)(New Type() {GetType(BirthdayAppointment)})
		End Get
	End Property

	Public Overrides Function Serialize(ByVal obj As Object, ByVal serializer As System.Web.Script.Serialization.JavaScriptSerializer) As IDictionary(Of String, Object)
		Dim bApp As BirthdayAppointment = TryCast(obj, BirthdayAppointment)
		If bApp IsNot Nothing Then
			Dim json As IDictionary(Of String, Object) = MyBase.Serialize(obj, serializer)
			If json IsNot Nothing Then
				json.Add("itemType", "custom:bapp")
				json.Add("birthDate", bApp.BirthDate)
				json.Add("person", bApp.BirthdayPerson)
			End If
			Return json
		End If
		Return Nothing

	End Function
End Class

