﻿'
' Copyright (c) 2009-2015, MindFusion LLC - Bulgaria.
'
Imports MindFusion.Scheduling

Partial Public Class _Default
	Inherits System.Web.UI.Page
	Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
		If Not IsPostBack Then
			If Schedule.IsClassRegistered("custom:bapp") Then
				Schedule.UnregisterClass("custom:bapp")
			End If
			Schedule.RegisterItemClass(GetType(BirthdayAppointment), "custom:bapp", 1)

			For i As Integer = 0 To 39
				Dim bDay As New BirthdayAppointment(GenerateRandomBirthDate(), GenerateRandomName())
				Calendar1.Schedule.Items.Add(bDay)
			Next

			Dim normalApp As New Appointment()
			normalApp.HeaderText = "Regular app"
			normalApp.StartTime = DateTime.Now
			normalApp.EndTime = normalApp.StartTime.AddHours(5)
			Calendar1.Schedule.Items.Add(normalApp)
			Dim todayBApp As New BirthdayAppointment(New DateTime(1984, today.Month, today.Day), "Ringo")
			Calendar1.Schedule.Items.Add(todayBApp)
		End If
	End Sub

	Private Function GenerateRandomBirthDate() As DateTime
		Dim year As Integer = rnd.[Next](1964, 2001)
		Dim month As Integer = rnd.[Next](1, 12)
		Dim day As Integer = rnd.[Next](1, DateTime.DaysInMonth(year, month))
		Return New DateTime(year, month, day)
	End Function
	Private Function GenerateRandomName() As String
		Dim male As Boolean = rnd.[Next](0, 5000) Mod 2 = 0
		If male Then
			Return mNames(rnd.[Next](0, mNames.Length - 1))
		End If
		Return fNames(rnd.[Next](0, fNames.Length - 1))
	End Function

	Protected Sub Calendar1_ItemSerialization(ByVal sender As Object, ByVal e As SerializationEventArgs) Handles Calendar1.ItemSerialization
        e.addDefaultConverter = True
        e.serializer.RegisterConverters(New System.Web.Script.Serialization.JavaScriptConverter() {New BirthdayAppointmentConverter(Calendar1)})
	End Sub

	Private Shared ReadOnly mNames As String() = New String() {"James", "David", "Christopher", "George", "Ronald", "John", _
	 "Richard", "Daniel", "Kenneth", "Anthony", "Robert", "Charles", _
	 "Paul", "Steven", "Kevin", "Michael", "Joseph", "Mark", _
	 "Edward", "Jason", "William", "Thomas", "Donald", "Brian", _
	 "Jeff"}
	Private Shared ReadOnly fNames As String() = New String() {"Mary", "Jennifer", "Lisa", "Sandra", "Michelle", "Patricia", _
	 "Maria", "Nancy", "Donna", "Laura", "Linda", "Susan", _
	 "Karen", "Carol", "Sarah", "Barbara", "Margaret", "Betty", _
	 "Ruth", "Kimberly", "Elizabeth", "Dorothy", "Helen", "Sharon", _
	 "Deborah"}
	Private Shared ReadOnly rnd As New Random(DateTime.Now.Millisecond)
	Private Shared ReadOnly today As DateTime = DateTime.Today
End Class
